#include "LibFunciones.h"

int main(){

    int opcion=1,i,j,num,term_usr=0,term_ord=0,cont=4;
    char menu=NULL,car;
    int mat_ord[FILAS][COLUMNAS];
    int mat_usr[FILAS][COLUMNAS];
    //Se crean dos matrices para cada jugador, en este caso el usuario y el ordendor

    FILE *fichero;

    srand(time(NULL)); //Para hacer aleatorio quien emieza, se inicializa la funcion

    SetConsoleTitle("Hundir la Flota");


    HANDLE handle = GetStdHandle(STD_OUTPUT_HANDLE);

    COORD a;
    a.X = 80;
    a.Y = 35;

    SetConsoleScreenBufferSize(handle, a);


    menu_ppal();


    printf("\n\n\n\n\t\t   HUNDIR LA FLOTA");

    printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",218,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,191);
    printf("\n\t\t\t\t\t\t\t %c Nueva partida %c",179,179);
    printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",192,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,217);
    printf("\n\n \t\t\t\t\t\t           Cargar partida");
    printf("\n\n\n \t\t\t\t\t\t           Instrucciones");
    printf("\n\n\n\t\t\t\t\t\t\t       Salir\n");

    fondo();

     do{

        if(menu<3 && menu>0)
        {
            fflush(stdin);
            menu=getch();
        }

        else menu=1;


        switch(menu)
        {

            case 80:
                if(opcion<4)
                    opcion++;
                    break;
            case 72:
                if(opcion>1)
                    opcion--;
                    break;
        }

    //Control de la interfaz utilizando las teclas de direccion para que sea mas amigable

        switch(opcion){


            case 1:

                system("cls");
                printf("\n\n\n\n\t\t   HUNDIR LA FLOTA");

                printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",218,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,191);
                printf("\n\t\t\t\t\t\t\t %c Nueva partida %c",179,179);
                printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",192,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,217);
                printf("\n\n \t\t\t\t\t\t           Cargar partida");
                printf("\n\n\n \t\t\t\t\t\t           Instrucciones");
                printf("\n\n\n\t\t\t\t\t\t\t       Salir\n");

                fondo();

                if (menu == 13)
                {


                    if (! (fichero = fopen ("miniflota_g.dat", "rb")))
                    {
                        //Se comprueba si existe el fichero con la partida guardada para que se pueda reaundar la partida directamente
                        //si no hay partidas guardadas se comienza una nueva
                        inicializar_mat(mat_ord);
                        inicializar_mat(mat_usr);

                        posiciones_ord(mat_ord);
                        posiciones_usr(mat_usr);
                        jug_ale(mat_ord, mat_usr,&num);
                        mostrartab(mat_ord, mat_usr);

                        printf("\n    ");
                        system("pause");
                        partida(mat_ord, mat_usr,num,term_usr,term_ord);


                    }
                    else
                    {

                        do{
                            system("cls");
                            printf("\n\n\n\n\n\n\n\t\tDESEAS CONTINUAR LA PARTIDA ?  Si/No/Volver (s/n/v): ");
                            //EN el caso de que ya exista un apartida, se pregunta si se quieres seguir, si el susraio quiere crear un a nueva o si quiere volver al menu principal
                            scanf("%c",&car);
                            car = tolower(car);

                        }while(car!= 's' && car!='n' && car!='v');



                        switch(car){

                            case 'v': break;

                            case 's':

                                // Se inicializan las matrices para evitar errores y que esten vacios y despues sobre ellos cargar el fichero
                                inicializar_mat(mat_ord);
                                inicializar_mat(mat_usr);

                                cargar(mat_usr,mat_ord, num);
                                mostrartab(mat_ord, mat_usr);
                                system("pause");

                                term_ord=0;
                                term_usr=0;


                                partida(mat_ord, mat_usr,0,term_usr,term_ord);

                                system("color F0");

                                break;

                            case 'n':

                                inicializar_mat(mat_ord);
                                inicializar_mat(mat_usr);

                                posiciones_ord(mat_ord);
                                posiciones_usr(mat_usr);
                                jug_ale(mat_ord, mat_usr,&num);
                                mostrartab(mat_ord, mat_usr);

                                partida(mat_ord, mat_usr,num,term_usr,term_ord);


                                break;

                        }

                    }

                    fclose(fichero);

                }

                break;

            case 2:

                system("cls");

                printf("\n\n\n\n\t\t   HUNDIR LA FLOTA");

                printf("\n\n\t\t\t\t\t\t\t   Nueva partida");
                printf("\n\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%C",218,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,191);
                printf("\n \t\t\t\t\t\t         %c Cargar partida %c",179,179);
                printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",192,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,217);
                printf("\n\n \t\t\t\t\t\t           Instrucciones\n");
                printf("\n\n\t\t\t\t\t\t\t       Salir\n");

                fondo();

                if (menu == 13)//Cargar partida, si existe el fichero, se carga la partida al igual que en el caso 1 diciendo si
                    {

                        inicializar_mat(mat_ord);
                        inicializar_mat(mat_usr);

                        num=cargar(mat_usr,mat_ord, &num);

                        term_ord=0;
                        term_usr=0;

                        if(num!=1)
                            partida(mat_ord, mat_usr,0,term_usr,term_ord);//0 es para que en la funcion partida, si num es 0 empieza el usuario que ha sido el que tenia el turno

                        system("color F0");

                    }
                break;


            case 3:

                system("cls");

                printf("\n\n\n\n\t\t   HUNDIR LA FLOTA");

                printf("\n\n\t\t\t\t\t\t\t   Nueva partida");
                printf("\n\n\n \t\t\t\t\t\t           Cargar partida\n");
                printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",218,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,191);
                printf("\n \t\t\t\t\t\t         %c Instrucciones %c",179,179);
                printf("\n\t\t\t\t\t\t\t %c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",192,196,196,196,196,196,196,196,196,196,196,196,196,196,196,196,217);
                printf("\n\n\t\t\t\t\t\t\t       Salir\n");
                fondo();

                if (menu == 13)
                    instrucciones();

                break;


            case 4:

                system("cls");

                printf("\n\n\n\n\t\t   HUNDIR LA FLOTA");

                printf("\n\n\t\t\t\t\t\t\t   Nueva partida");
                printf("\n\n\n \t\t\t\t\t\t           Cargar partida");
                printf("\n\n\n \t\t\t\t\t\t           Instrucciones\n");
                printf("\n\t\t\t\t\t\t\t     %c%c%c%c%c%c%c%c%c",218,196,196,196,196,196,196,196,191);
                printf("\n\t\t\t\t\t\t\t     %c Salir %c",179,179);
                printf("\n\t\t\t\t\t\t\t     %c%c%c%c%c%c%c%c%c",192,196,196,196,196,196,196,196,217);

                fondo();

                if (menu == 13)
                    salir();

                break;
        }

    }while(menu!='\n');

    return 0;
}

void partida(char mat_ord[FILAS][COLUMNAS], char mat_usr[FILAS][COLUMNAS],int num,int term_ord, int term_usr){

    int term=0;
//Funcion para facilitar el poder cargar las partidas y guardarlas de tal forma que llamado a la funcion es
// posible poder jugar en vez de aadir el cadigo cuando se quiera cargar una partida
    if(num == 0)
    {//USUARIO
        do{


            comprobar(mat_ord, &term_ord);
            comprobar(mat_usr, &term_usr);
            mostrartab(mat_ord, mat_usr);
            pos_usr(mat_usr, mat_ord, num, &term_usr, &term_ord);

            if(term_ord!=2 || term_usr!=2)
            {
                comprobar(mat_ord, &term_ord);
                comprobar(mat_usr, &term_usr);
            }

            mostrartab(mat_ord, mat_usr);
            if(term_usr==1)
                pos_ord(mat_usr, mat_ord);


            if(term_ord!=2 || term_usr!=2)
            {
                comprobar(mat_ord, &term_ord);
                comprobar(mat_usr, &term_usr);
                mostrartab(mat_ord, mat_usr);
            }


        }while(term_usr==1 && term_ord==1);


        system("color F0");

        if(term_usr==1)
        {
            remove("miniflota_g.dat");
            system("cls");
            printf("\n\n\n\n\n\n\n\t\t\t\t   %cENHORABUENA!",173);
            printf("\n\n\n\n\n\t\t\t\t  GANA EL USUARIO");

            puts("\n\n\n\n\n\n\t\t\t   Pulsa una tecla para continuar");
            getche();

        }
        else if(term_ord==1)
        {
            remove("miniflota_g.dat");
            system("cls");
            printf("\n\n\n\n\n\n\n\t\t\t\t       L%cSTIMA",181);
            printf("\n\n\n\n\n\t\t\t\t GANA EL ORDENADOR");

            puts("\n\n\n\n\n\n\t\t\t   Pulsa una tecla para continuar");
            getche();

        }

    }
    else if(num == 1)
    {//ORDENADOR

        do{


            comprobar(mat_ord, &term_ord);
            comprobar(mat_usr, &term_usr);
            mostrartab(mat_ord, mat_usr);
            pos_ord(mat_usr, mat_ord);

            if(term_ord!=2 || term_usr!=2)
            {
                comprobar(mat_ord, &term_ord);
                comprobar(mat_usr, &term_usr);
            }

            mostrartab(mat_ord, mat_usr);

            if(term_ord==1)
                pos_usr(mat_usr, mat_ord, num, &term_usr, &term_ord);

            if(term_ord!=2 || term_usr!=2)
            {
                comprobar(mat_ord, &term_ord);
                comprobar(mat_usr, &term_usr);
                mostrartab(mat_ord, mat_usr);
            }


        }while(term_usr==1 && term_ord==1);


        system("color F0");

        if(term_usr==1)
        {
            remove("miniflota_g.dat");
            system("cls");
            printf("\n\n\n\n\n\n\n\t\t\t\t   %cENHORABUENA!",173);
            printf("\n\n\n\n\n\t\t\t\t  GANA EL USUARIO");

            puts("\n\n\n\n\n\n\t\t\t   Pulsa una tecla para continuar");
            getche();

        }
        else if(term_ord==1)
        {
            remove("miniflota_g.dat");
            system("cls");
            printf("\n\n\n\n\n\n\n\t\t\t\t       L%cSTIMA",181);
            printf("\n\n\n\n\n\t\t\t\t GANA EL ORDENADOR");

            puts("\n\n\n\n\n\n\t\t\t   Pulsa una tecla para continuar");
            getche();

        }

    }


}
